package com.siwei.recyclebox.ui.main;

import android.Manifest;
import android.app.AlarmManager;
import android.app.PendingIntent;
import android.arch.lifecycle.Observer;
import android.content.Context;
import android.content.Intent;
import android.databinding.ViewDataBinding;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.util.Log;
import android.view.View;

import com.siwei.recyclebox.BR;
import com.siwei.recyclebox.R;
import com.siwei.recyclebox.databinding.ActivityMainBinding;
import com.siwei.recyclebox.deviceUtils.SerialPortUtil;
import com.siwei.recyclebox.service.MyService;
import com.tbruyelle.rxpermissions2.RxPermissions;

import java.io.IOException;

import io.reactivex.disposables.Disposable;
import me.goldze.mvvmhabit.base.BaseActivity;
import me.goldze.mvvmhabit.utils.SPUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class MainActivity extends BaseActivity<ViewDataBinding,MainViewModel> {

    private static final String TAG = "MainActivity";

    //页面接收的参数方法
    @Override
    public void initParam() {
        super.initParam();
        Intent service = new Intent(getApplication(), MyService.class);
        getApplication().startService(service);
    }

    //页面数据初始化方法。
    @Override
    public void initData() {
        super.initData();
//        viewModel.btnClick.onClick();
//        viewModel.btnText.set("");
        viewModel.registerAliIoTListener();
        viewModel.startBLEServer();
//        viewModel.netWorkInfo();
//        viewModel.openWeight();
//        System.out.println("serialPortUtil.readControllerStatus:"+ SerialPortUtil.getInstance().readRelayControllerStatus());

    }

    @Override
    public void initViewObservable() {
        super.initViewObservable();
        viewModel.requestFilePermissions.observe(this, aBoolean -> {
            //请求读写文件的权限。
            Log.d(TAG,"请求文件读写的权限");
            /*RxPermissions permissions = new RxPermissions(this);
            Disposable disposable =permissions.request(new String[]{Manifest.permission.WRITE_EXTERNAL_STORAGE,Manifest.permission.READ_EXTERNAL_STORAGE})
                .subscribe(granted->{
                    if(granted){
                        Log.d(TAG,"文件读写权限以获取！");
                        viewModel.otaListener();
                    }else{
                        ToastUtils.showShortSafe("请同意文件读写权限。");

                    }
            });*/

        });
    }

    @Override
    protected void onPause() {
        super.onPause();
    }

    @Override
    protected void onDestroy() {

        viewModel.closePort();
        viewModel.stopBleServer();
        viewModel.unRegisterIoTListener();
        Log.e("MainActivity.","unregisterIoTListener!!!");
        /*Intent mStartActivity = new Intent(getApplication(),MainActivity.class);
        int mPendingIntentId = 123456;
        PendingIntent mPendingIntent = PendingIntent.getActivity(getApplication(), mPendingIntentId,    mStartActivity, PendingIntent.FLAG_CANCEL_CURRENT);
        AlarmManager mgr = (AlarmManager)this.getSystemService(Context.ALARM_SERVICE);
        mgr.set(AlarmManager.RTC, System.currentTimeMillis() + 100, mPendingIntent);
        System.exit(0);*/
        super.onDestroy();

    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_main;
    }

    @Override
    public int initVariableId() {
        return BR.viewModal;
    }

    @Override
    public void onPointerCaptureChanged(boolean hasCapture) {
        System.out.println("onPointerCaptureChanged:"+hasCapture);
    }

    @Override
    public MainViewModel initViewModel() {
        //View持有ViewModel的引用，如果没有特殊业务处理，这个方法可以不重写
        return super.initViewModel();
    }
}
